# generated by datamodel-codegen:
#   filename:  slurm-v42.json
#   timestamp: 2025-02-20T15:00:06+00:00

from typing import Any, Literal

from pydantic import BaseModel, Field, RootModel


class V42Float64NoValStruct(BaseModel):
    set: bool | None = Field(None, description="True if number has been set; False if number is unset")
    infinite: bool | None = Field(
        None,
        description='True if number has been set to infinite; "set" and "number" will be ignored',
    )
    number: float | None = Field(
        None,
        description='If "set" is True the number will be set with value; otherwise ignore number contents',
    )


class V42Uint32NoValStruct(BaseModel):
    set: bool | None = Field(None, description="True if number has been set; False if number is unset")
    infinite: bool | None = Field(
        None,
        description='True if number has been set to infinite; "set" and "number" will be ignored',
    )
    number: int | None = Field(
        None,
        description='If "set" is True the number will be set with value; otherwise ignore number contents',
    )


class V42Uint64NoValStruct(BaseModel):
    set: bool | None = Field(None, description="True if number has been set; False if number is unset")
    infinite: bool | None = Field(
        None,
        description='True if number has been set to infinite; "set" and "number" will be ignored',
    )
    number: int | None = Field(
        None,
        description='If "set" is True the number will be set with value; otherwise ignore number contents',
    )


class V42SharesFloat128Tres(BaseModel):
    name: str | None = Field(None, description="TRES name")
    value: float | None = Field(None, description="TRES value")


class V42AssocSharesObjWrapType(RootModel[list[Literal["USER", "ASSOCIATION"]]]):
    root: list[Literal["USER", "ASSOCIATION"]]


class Plugin(BaseModel):
    type: str | None = Field(None, description="Slurm plugin type (if applicable)")
    name: str | None = Field(None, description="Slurm plugin name (if applicable)")
    data_parser: str | None = Field(None, description="Slurm data_parser plugin")
    accounting_storage: str | None = Field(None, description="Slurm accounting plugin")


class Client(BaseModel):
    source: str | None = Field(None, description="Client source description")
    user: str | None = Field(None, description="Client user (if known)")
    group: str | None = Field(None, description="Client group (if known)")


class Version(BaseModel):
    major: str | None = Field(None, description="Slurm release major version")
    micro: str | None = Field(None, description="Slurm release micro version")
    minor: str | None = Field(None, description="Slurm release minor version")


class Slurm(BaseModel):
    version: Version | None = None
    release: str | None = Field(None, description="Slurm release string")
    cluster: str | None = Field(None, description="Slurm cluster name")


class V42StringArray(RootModel[list[str]]):
    root: list[str]


class V42OpenapiError(BaseModel):
    description: str | None = Field(None, description="Long form error description")
    error_number: int | None = Field(None, description="Slurm numeric error identifier")
    error: str | None = Field(None, description="Short form error description")
    source: str | None = Field(None, description="Source of error or where error was first detected")


class V42OpenapiWarning(BaseModel):
    description: str | None = Field(None, description="Long form warning description")
    source: str | None = Field(None, description="Source of warning or where warning was first detected")


class V42ScheduleExitFields(BaseModel):
    end_job_queue: int | None = Field(None, description="Reached end of queue")
    default_queue_depth: int | None = Field(None, description="Reached number of jobs allowed to be tested")
    max_job_start: int | None = Field(None, description="Reached number of jobs allowed to start")
    max_rpc_cnt: int | None = Field(None, description="Reached RPC limit")
    max_sched_time: int | None = Field(None, description="Reached maximum allowed scheduler time")
    licenses: int | None = Field(None, description="Blocked on licenses")


class V42BfExitFields(BaseModel):
    end_job_queue: int | None = Field(None, description="Reached end of queue")
    bf_max_job_start: int | None = Field(None, description="Reached number of jobs allowed to start")
    bf_max_job_test: int | None = Field(None, description="Reached number of jobs allowed to be tested")
    bf_max_time: int | None = Field(None, description="Reached maximum allowed scheduler time")
    bf_node_space_size: int | None = Field(None, description="Reached table size limit")
    state_changed: int | None = Field(None, description="System state changed")


class V42StatsMsgRpcType(BaseModel):
    type_id: int = Field(..., description="Message type as integer")
    message_type: str = Field(..., description="Message type as string")
    count: int = Field(..., description="Number of RPCs received")
    queued: int = Field(..., description="Number of RPCs queued")
    dropped: int = Field(..., description="Number of RPCs dropped")
    cycle_last: int = Field(..., description="Number of RPCs processed within the last RPC queue cycle")
    cycle_max: int = Field(
        ...,
        description="Maximum number of RPCs processed within a RPC queue cycle since start",
    )
    total_time: int = Field(..., description="Total time spent processing RPC in seconds")
    average_time: V42Uint64NoValStruct = Field(..., description="Average time spent processing RPC in seconds")


class V42StatsMsgRpcUser(BaseModel):
    user_id: int = Field(..., description="User ID (numeric)")
    user: str = Field(..., description="User name")
    count: int = Field(..., description="Number of RPCs received")
    total_time: int = Field(..., description="Total time spent processing RPC in seconds")
    average_time: V42Uint64NoValStruct = Field(..., description="Average time spent processing RPC in seconds")


class V42StatsMsgRpcQueue(BaseModel):
    type_id: int = Field(..., description="Message type as integer")
    message_type: str = Field(..., description="Message type as string")
    count: int = Field(..., description="Number of pending RPCs queued")


class V42HostlistString(RootModel[list[str]]):
    root: list[str]


class V42ControllerPing(BaseModel):
    hostname: str | None = Field(None, description="Target for ping")
    pinged: str | None = Field(None, description="Ping result")
    responding: bool = Field(..., description="If ping RPC responded with pong from controller")
    latency: int | None = Field(
        None,
        description="Number of microseconds it took to successfully ping or timeout",
    )
    mode: str | None = Field(None, description="The operating mode of the responding slurmctld")
    primary: bool = Field(..., description="Is responding slurmctld the primary controller")


class V42License(BaseModel):
    LicenseName: str | None = Field(None, description="Name of the license")
    Total: int | None = Field(None, description="Total number of licenses present")
    Used: int | None = Field(None, description="Number of licenses in use")
    Free: int | None = Field(None, description="Number of licenses currently available")
    Remote: bool | None = Field(None, description="Indicates whether licenses are served by the database")
    Reserved: int | None = Field(None, description="Number of licenses reserved")
    LastConsumed: int | None = Field(
        None,
        description="Last known number of licenses that were consumed in the license manager (Remote Only)",
    )
    LastDeficit: int | None = Field(None, description='Number of "missing licenses" from the cluster\'s perspective')
    LastUpdate: int | None = Field(
        None,
        description="When the license information was last updated (UNIX Timestamp)",
    )


class Rlimits(BaseModel):
    cpu: V42Uint64NoValStruct | None = Field(None, description="Per-process CPU limit, in seconds")
    fsize: V42Uint64NoValStruct | None = Field(None, description="Largest file that can be created, in bytes")
    data: V42Uint64NoValStruct | None = Field(None, description="Maximum size of data segment, in bytes")
    stack: V42Uint64NoValStruct | None = Field(None, description="Maximum size of stack segment, in bytes")
    core: V42Uint64NoValStruct | None = Field(None, description="Largest core file that can be created, in bytes")
    rss: V42Uint64NoValStruct | None = Field(
        None,
        description="Largest resident set size, in bytes. This affects swapping; processes that are exceeding their resident set size will be more likely to have physical memory taken from them",
    )
    nproc: V42Uint64NoValStruct | None = Field(None, description="Number of processes")
    nofile: V42Uint64NoValStruct | None = Field(None, description="Number of open files")
    memlock: V42Uint64NoValStruct | None = Field(None, description="Locked-in-memory address space")
    as_: V42Uint64NoValStruct | None = Field(None, alias="as", description="Address space limit")


class V42JobFlags(
    RootModel[
        list[
            Literal[
                "KILL_INVALID_DEPENDENCY",
                "NO_KILL_INVALID_DEPENDENCY",
                "HAS_STATE_DIRECTORY",
                "TESTING_BACKFILL",
                "GRES_BINDING_ENFORCED",
                "TEST_NOW_ONLY",
                "SEND_JOB_ENVIRONMENT",
                "SPREAD_JOB",
                "PREFER_MINIMUM_NODE_COUNT",
                "JOB_KILL_HURRY",
                "SKIP_TRES_STRING_ACCOUNTING",
                "SIBLING_CLUSTER_UPDATE_ONLY",
                "HETEROGENEOUS_JOB",
                "EXACT_TASK_COUNT_REQUESTED",
                "EXACT_CPU_COUNT_REQUESTED",
                "TESTING_WHOLE_NODE_BACKFILL",
                "TOP_PRIORITY_JOB",
                "ACCRUE_COUNT_CLEARED",
                "GRES_BINDING_DISABLED",
                "JOB_WAS_RUNNING",
                "JOB_ACCRUE_TIME_RESET",
                "CRON_JOB",
                "EXACT_MEMORY_REQUESTED",
                "USING_DEFAULT_ACCOUNT",
                "USING_DEFAULT_PARTITION",
                "USING_DEFAULT_QOS",
                "USING_DEFAULT_WCKEY",
                "DEPENDENT",
                "MAGNETIC",
                "PARTITION_ASSIGNED",
                "BACKFILL_ATTEMPTED",
                "SCHEDULING_ATTEMPTED",
                "STEPMGR_ENABLED",
            ]
        ]
    ]
):
    root: list[
        Literal[
            "KILL_INVALID_DEPENDENCY",
            "NO_KILL_INVALID_DEPENDENCY",
            "HAS_STATE_DIRECTORY",
            "TESTING_BACKFILL",
            "GRES_BINDING_ENFORCED",
            "TEST_NOW_ONLY",
            "SEND_JOB_ENVIRONMENT",
            "SPREAD_JOB",
            "PREFER_MINIMUM_NODE_COUNT",
            "JOB_KILL_HURRY",
            "SKIP_TRES_STRING_ACCOUNTING",
            "SIBLING_CLUSTER_UPDATE_ONLY",
            "HETEROGENEOUS_JOB",
            "EXACT_TASK_COUNT_REQUESTED",
            "EXACT_CPU_COUNT_REQUESTED",
            "TESTING_WHOLE_NODE_BACKFILL",
            "TOP_PRIORITY_JOB",
            "ACCRUE_COUNT_CLEARED",
            "GRES_BINDING_DISABLED",
            "JOB_WAS_RUNNING",
            "JOB_ACCRUE_TIME_RESET",
            "CRON_JOB",
            "EXACT_MEMORY_REQUESTED",
            "USING_DEFAULT_ACCOUNT",
            "USING_DEFAULT_PARTITION",
            "USING_DEFAULT_QOS",
            "USING_DEFAULT_WCKEY",
            "DEPENDENT",
            "MAGNETIC",
            "PARTITION_ASSIGNED",
            "BACKFILL_ATTEMPTED",
            "SCHEDULING_ATTEMPTED",
            "STEPMGR_ENABLED",
        ]
    ]


class V42CpuBindingFlags(
    RootModel[
        list[
            Literal[
                "CPU_BIND_TO_THREADS",
                "CPU_BIND_TO_CORES",
                "CPU_BIND_TO_SOCKETS",
                "CPU_BIND_TO_LDOMS",
                "CPU_BIND_NONE",
                "CPU_BIND_RANK",
                "CPU_BIND_MAP",
                "CPU_BIND_MASK",
                "CPU_BIND_LDRANK",
                "CPU_BIND_LDMAP",
                "CPU_BIND_LDMASK",
                "VERBOSE",
                "CPU_BIND_ONE_THREAD_PER_CORE",
            ]
        ]
    ]
):
    root: list[
        Literal[
            "CPU_BIND_TO_THREADS",
            "CPU_BIND_TO_CORES",
            "CPU_BIND_TO_SOCKETS",
            "CPU_BIND_TO_LDOMS",
            "CPU_BIND_NONE",
            "CPU_BIND_RANK",
            "CPU_BIND_MAP",
            "CPU_BIND_MASK",
            "CPU_BIND_LDRANK",
            "CPU_BIND_LDMAP",
            "CPU_BIND_LDMASK",
            "VERBOSE",
            "CPU_BIND_ONE_THREAD_PER_CORE",
        ]
    ]


class Line(BaseModel):
    start: int | None = Field(None, description="Start of this entry in file")
    end: int | None = Field(None, description="End of this entry in file")


class V42CronEntryFlags(
    RootModel[
        list[
            Literal[
                "WILD_MINUTE",
                "WILD_HOUR",
                "WILD_DAY_OF_MONTH",
                "WILD_MONTH",
                "WILD_DAY_OF_WEEK",
            ]
        ]
    ]
):
    root: list[
        Literal[
            "WILD_MINUTE",
            "WILD_HOUR",
            "WILD_DAY_OF_MONTH",
            "WILD_MONTH",
            "WILD_DAY_OF_WEEK",
        ]
    ]


class V42CsvString(RootModel[list[str]]):
    root: list[str]


class V42JobMailFlags(
    RootModel[
        list[
            Literal[
                "BEGIN",
                "END",
                "FAIL",
                "REQUEUE",
                "TIME=100%",
                "TIME=90%",
                "TIME=80%",
                "TIME=50%",
                "STAGE_OUT",
                "ARRAY_TASKS",
                "INVALID_DEPENDENCY",
            ]
        ]
    ]
):
    root: list[
        Literal[
            "BEGIN",
            "END",
            "FAIL",
            "REQUEUE",
            "TIME=100%",
            "TIME=90%",
            "TIME=80%",
            "TIME=50%",
            "STAGE_OUT",
            "ARRAY_TASKS",
            "INVALID_DEPENDENCY",
        ]
    ]


class V42MemoryBindingType(
    RootModel[list[Literal["NONE", "RANK", "MAP", "MASK", "LOCAL", "VERBOSE", "SORT", "PREFER"]]]
):
    root: list[Literal["NONE", "RANK", "MAP", "MASK", "LOCAL", "VERBOSE", "SORT", "PREFER"]]


class V42OpenMode(RootModel[list[Literal["APPEND", "TRUNCATE"]]]):
    root: list[Literal["APPEND", "TRUNCATE"]]


class V42Uint16NoValStruct(BaseModel):
    set: bool | None = Field(None, description="True if number has been set; False if number is unset")
    infinite: bool | None = Field(
        None,
        description='True if number has been set to infinite; "set" and "number" will be ignored',
    )
    number: int | None = Field(
        None,
        description='If "set" is True the number will be set with value; otherwise ignore number contents',
    )


class V42AcctGatherProfile(RootModel[list[Literal["NOT_SET", "NONE", "ENERGY", "LUSTRE", "NETWORK", "TASK"]]]):
    root: list[Literal["NOT_SET", "NONE", "ENERGY", "LUSTRE", "NETWORK", "TASK"]]


class V42JobShared(RootModel[list[Literal["none", "oversubscribe", "user", "mcs", "topo"]]]):
    root: list[Literal["none", "oversubscribe", "user", "mcs", "topo"]]


class V42WarnFlags(
    RootModel[
        list[
            Literal[
                "BATCH_JOB",
                "ARRAY_TASK",
                "FULL_STEPS_ONLY",
                "FULL_JOB",
                "FEDERATION_REQUEUE",
                "HURRY",
                "OUT_OF_MEMORY",
                "NO_SIBLING_JOBS",
                "RESERVATION_JOB",
                "VERBOSE",
                "CRON_JOBS",
                "WARNING_SENT",
            ]
        ]
    ]
):
    root: list[
        Literal[
            "BATCH_JOB",
            "ARRAY_TASK",
            "FULL_STEPS_ONLY",
            "FULL_JOB",
            "FEDERATION_REQUEUE",
            "HURRY",
            "OUT_OF_MEMORY",
            "NO_SIBLING_JOBS",
            "RESERVATION_JOB",
            "VERBOSE",
            "CRON_JOBS",
            "WARNING_SENT",
        ]
    ]


class V42X11Flags(RootModel[list[Literal["FORWARD_ALL_NODES", "BATCH_NODE", "FIRST_NODE", "LAST_NODE"]]]):
    root: list[Literal["FORWARD_ALL_NODES", "BATCH_NODE", "FIRST_NODE", "LAST_NODE"]]


class Power(BaseModel):
    flags: list | None = None


class Signal(BaseModel):
    id: V42Uint16NoValStruct | None = Field(None, description="Signal sent to process (numeric)")
    name: str | None = Field(None, description="Signal sent to process (name)")


class V42ProcessExitCodeStatus(
    RootModel[list[Literal["INVALID", "PENDING", "SUCCESS", "ERROR", "SIGNALED", "CORE_DUMPED"]]]
):
    root: list[Literal["INVALID", "PENDING", "SUCCESS", "ERROR", "SIGNALED", "CORE_DUMPED"]]


class V42JobInfoGresDetail(RootModel[list[str]]):
    root: list[str]


class V42CrType(
    RootModel[
        list[
            Literal[
                "CPU",
                "SOCKET",
                "CORE",
                "BOARD",
                "MEMORY",
                "ONE_TASK_PER_CORE",
                "PACK_NODES",
                "CORE_DEFAULT_DIST_BLOCK",
                "LLN",
                "LINEAR",
            ]
        ]
    ]
):
    root: list[
        Literal[
            "CPU",
            "SOCKET",
            "CORE",
            "BOARD",
            "MEMORY",
            "ONE_TASK_PER_CORE",
            "PACK_NODES",
            "CORE_DEFAULT_DIST_BLOCK",
            "LLN",
            "LINEAR",
        ]
    ]


class V42NodeCrType(RootModel[list[Literal["AVAILABLE", "ONE_ROW", "RESERVED"]]]):
    root: list[Literal["AVAILABLE", "ONE_ROW", "RESERVED"]]


class Cpus(BaseModel):
    count: int | None = Field(None, description="Total number of CPUs assigned to job")
    used: int | None = Field(None, description="Total number of CPUs used by job")


class Memory(BaseModel):
    used: int | None = Field(None, description="Total memory (MiB) used by job")
    allocated: int | None = Field(None, description="Total memory (MiB) allocated to job")


class V42JobResCoreStatus(RootModel[list[Literal["INVALID", "UNALLOCATED", "ALLOCATED", "IN_USE"]]]):
    root: list[Literal["INVALID", "UNALLOCATED", "ALLOCATED", "IN_USE"]]


class V42JobState(
    RootModel[
        list[
            Literal[
                "PENDING",
                "RUNNING",
                "SUSPENDED",
                "COMPLETED",
                "CANCELLED",
                "FAILED",
                "TIMEOUT",
                "NODE_FAIL",
                "PREEMPTED",
                "BOOT_FAIL",
                "DEADLINE",
                "OUT_OF_MEMORY",
                "LAUNCH_FAILED",
                "REQUEUED",
                "REQUEUE_HOLD",
                "SPECIAL_EXIT",
                "RESIZING",
                "CONFIGURING",
                "COMPLETING",
                "STOPPED",
                "RECONFIG_FAIL",
                "POWER_UP_NODE",
                "REVOKED",
                "REQUEUE_FED",
                "RESV_DEL_HOLD",
                "SIGNALING",
                "STAGE_OUT",
            ]
        ]
    ]
):
    root: list[
        Literal[
            "PENDING",
            "RUNNING",
            "SUSPENDED",
            "COMPLETED",
            "CANCELLED",
            "FAILED",
            "TIMEOUT",
            "NODE_FAIL",
            "PREEMPTED",
            "BOOT_FAIL",
            "DEADLINE",
            "OUT_OF_MEMORY",
            "LAUNCH_FAILED",
            "REQUEUED",
            "REQUEUE_HOLD",
            "SPECIAL_EXIT",
            "RESIZING",
            "CONFIGURING",
            "COMPLETING",
            "STOPPED",
            "RECONFIG_FAIL",
            "POWER_UP_NODE",
            "REVOKED",
            "REQUEUE_FED",
            "RESV_DEL_HOLD",
            "SIGNALING",
            "STAGE_OUT",
        ]
    ]


class V42PartPrio(BaseModel):
    partition: str | None = Field(None, description="Partition name")
    priority: int | None = Field(None, description="Prospective job priority if it runs in this partition")


class Error(BaseModel):
    string: str | None = Field(None, description="String error encountered signaling job")
    code: int | None = Field(None, description="Numeric error encountered signaling job")
    message: str | None = Field(None, description="Error message why signaling job failed")


class Federation(BaseModel):
    sibling: str | None = Field(None, description="Name of federation sibling (may be empty for non-federation)")


class V42KillJobsRespJob(BaseModel):
    error: Error | None = None
    step_id: str = Field(..., description="Job or Step ID that signaling failed")
    job_id: V42Uint32NoValStruct = Field(..., description="Job ID that signaling failed")
    federation: Federation | None = None


class V42KillJobsMsgJobsArray(RootModel[list[str]]):
    root: list[str]


class V42JobArrayResponseMsgEntry(BaseModel):
    job_id: int | None = Field(None, description="Job ID for updated job")
    step_id: str | None = Field(None, description="Step ID for updated job")
    error: str | None = Field(None, description="Verbose update status or error")
    error_code: int | None = Field(None, description="Verbose update status or error")
    why: str | None = Field(None, description="Update response message")


class V42AcctGatherEnergy(BaseModel):
    average_watts: int | None = Field(None, description="Average power consumption, in watts")
    base_consumed_energy: int | None = Field(
        None,
        description="The energy consumed between when the node was powered on and the last time it was registered by slurmd, in joules",
    )
    consumed_energy: int | None = Field(
        None,
        description="The energy consumed between the last time the node was registered by the slurmd daemon and the last node energy accounting sample, in joules",
    )
    current_watts: V42Uint32NoValStruct | None = Field(
        None,
        description="The instantaneous power consumption at the time of the last node energy accounting sample, in watts",
    )
    previous_consumed_energy: int | None = Field(None, description="Previous value of consumed_energy")
    last_collected: int | None = Field(None, description="Time when energy data was last retrieved (UNIX timestamp)")


class V42NodeStates(
    RootModel[
        list[
            Literal[
                "INVALID",
                "UNKNOWN",
                "DOWN",
                "IDLE",
                "ALLOCATED",
                "ERROR",
                "MIXED",
                "FUTURE",
                "RESERVED",
                "UNDRAIN",
                "CLOUD",
                "RESUME",
                "DRAIN",
                "COMPLETING",
                "NOT_RESPONDING",
                "POWERED_DOWN",
                "FAIL",
                "POWERING_UP",
                "MAINTENANCE",
                "REBOOT_REQUESTED",
                "REBOOT_CANCELED",
                "POWERING_DOWN",
                "DYNAMIC_FUTURE",
                "REBOOT_ISSUED",
                "PLANNED",
                "INVALID_REG",
                "POWER_DOWN",
                "POWER_UP",
                "POWER_DRAIN",
                "DYNAMIC_NORM",
            ]
        ]
    ]
):
    root: list[
        Literal[
            "INVALID",
            "UNKNOWN",
            "DOWN",
            "IDLE",
            "ALLOCATED",
            "ERROR",
            "MIXED",
            "FUTURE",
            "RESERVED",
            "UNDRAIN",
            "CLOUD",
            "RESUME",
            "DRAIN",
            "COMPLETING",
            "NOT_RESPONDING",
            "POWERED_DOWN",
            "FAIL",
            "POWERING_UP",
            "MAINTENANCE",
            "REBOOT_REQUESTED",
            "REBOOT_CANCELED",
            "POWERING_DOWN",
            "DYNAMIC_FUTURE",
            "REBOOT_ISSUED",
            "PLANNED",
            "INVALID_REG",
            "POWER_DOWN",
            "POWER_UP",
            "POWER_DRAIN",
            "DYNAMIC_NORM",
        ]
    ]


class V42UpdateNodeMsg(BaseModel):
    comment: str | None = Field(None, description="Arbitrary comment")
    cpu_bind: int | None = Field(None, description="Default method for binding tasks to allocated CPUs")
    extra: str | None = Field(
        None,
        description="Arbitrary string used for node filtering if extra constraints are enabled",
    )
    features: V42CsvString | None = Field(None, description="Available features")
    features_act: V42CsvString | None = Field(None, description="Currently active features")
    gres: str | None = Field(None, description="Generic resources")
    address: V42HostlistString | None = Field(None, description="NodeAddr, used to establish a communication path")
    hostname: V42HostlistString | None = Field(None, description="NodeHostname")
    name: V42HostlistString | None = Field(None, description="NodeName")
    state: V42NodeStates | None = Field(None, description="New state to assign to the node")
    reason: str | None = Field(None, description="Reason for node being DOWN or DRAINING")
    reason_uid: str | None = Field(
        None,
        description="User ID to associate with the reason (needed if user root is sending message)",
    )
    resume_after: V42Uint32NoValStruct | None = Field(
        None,
        description="Number of seconds after which to automatically resume DOWN or DRAINED node",
    )
    weight: V42Uint32NoValStruct | None = Field(None, description="Weight of the node for scheduling purposes")


class Nodes1(BaseModel):
    allowed_allocation: str | None = Field(None, description="AllocNodes")
    configured: str | None = Field(None, description="Nodes")
    total: int | None = Field(None, description="TotalNodes")


class Accounts(BaseModel):
    allowed: str | None = Field(None, description="AllowAccounts")
    deny: str | None = Field(None, description="DenyAccounts")


class Groups(BaseModel):
    allowed: str | None = Field(None, description="AllowGroups")


class Qos(BaseModel):
    allowed: str | None = Field(None, description="AllowQOS")
    deny: str | None = Field(None, description="DenyQOS")
    assigned: str | None = Field(None, description="QOS")


class Tres1(BaseModel):
    billing_weights: str | None = Field(None, description="TRESBillingWeights")
    configured: str | None = Field(None, description="TRES")


class Cpus1(BaseModel):
    task_binding: int | None = Field(None, description="CpuBind")
    total: int | None = Field(None, description="TotalCPUs")


class Defaults(BaseModel):
    memory_per_cpu: int | None = Field(None, description="DefMemPerCPU or DefMemPerNode")
    partition_memory_per_cpu: V42Uint64NoValStruct | None = Field(None, description="DefMemPerCPU")
    partition_memory_per_node: V42Uint64NoValStruct | None = Field(None, description="DefMemPerNode")
    time: V42Uint32NoValStruct | None = Field(None, description="DefaultTime in minutes")
    job: str | None = Field(None, description="JobDefaults")


class Minimums(BaseModel):
    nodes: int | None = Field(None, description="MinNodes")


class Priority(BaseModel):
    job_factor: int | None = Field(None, description="PriorityJobFactor")
    tier: int | None = Field(None, description="PriorityTier")


class Timeouts(BaseModel):
    resume: V42Uint16NoValStruct | None = Field(
        None, description="ResumeTimeout (GLOBAL if both set and infinite are false)"
    )
    suspend: V42Uint16NoValStruct | None = Field(
        None, description="SuspendTimeout (GLOBAL if both set and infinite are false)"
    )


class V42OversubscribeFlags(RootModel[list[Literal["force"]]]):
    root: list[Literal["force"]]


class V42PartitionStates(RootModel[list[Literal["INACTIVE", "UNKNOWN", "UP", "DOWN", "DRAIN"]]]):
    root: list[Literal["INACTIVE", "UNKNOWN", "UP", "DOWN", "DRAIN"]]


class PurgeCompleted(BaseModel):
    time: V42Uint32NoValStruct | None = Field(
        None,
        description="If PURGE_COMP flag is set, the number of seconds this reservation will sit idle until it is revoked",
    )


class V42ReservationCoreSpec(BaseModel):
    node: str | None = Field(None, description="Name of reserved node")
    core: str | None = Field(None, description="IDs of reserved cores")


class V42ReservationFlags(
    RootModel[
        list[
            Literal[
                "MAINT",
                "NO_MAINT",
                "DAILY",
                "NO_DAILY",
                "WEEKLY",
                "NO_WEEKLY",
                "IGNORE_JOBS",
                "NO_IGNORE_JOBS",
                "ANY_NODES",
                "STATIC",
                "NO_STATIC",
                "PART_NODES",
                "NO_PART_NODES",
                "OVERLAP",
                "SPEC_NODES",
                "TIME_FLOAT",
                "REPLACE",
                "ALL_NODES",
                "PURGE_COMP",
                "WEEKDAY",
                "NO_WEEKDAY",
                "WEEKEND",
                "NO_WEEKEND",
                "FLEX",
                "NO_FLEX",
                "DURATION_PLUS",
                "DURATION_MINUS",
                "NO_HOLD_JOBS_AFTER_END",
                "NO_PURGE_COMP",
                "MAGNETIC",
                "SKIP",
                "HOURLY",
                "NO_HOURLY",
                "USER_DELETE",
                "NO_USER_DELETE",
                "REOCCURRING",
            ]
        ]
    ]
):
    root: list[
        Literal[
            "MAINT",
            "NO_MAINT",
            "DAILY",
            "NO_DAILY",
            "WEEKLY",
            "NO_WEEKLY",
            "IGNORE_JOBS",
            "NO_IGNORE_JOBS",
            "ANY_NODES",
            "STATIC",
            "NO_STATIC",
            "PART_NODES",
            "NO_PART_NODES",
            "OVERLAP",
            "SPEC_NODES",
            "TIME_FLOAT",
            "REPLACE",
            "ALL_NODES",
            "PURGE_COMP",
            "WEEKDAY",
            "NO_WEEKDAY",
            "WEEKEND",
            "NO_WEEKEND",
            "FLEX",
            "NO_FLEX",
            "DURATION_PLUS",
            "DURATION_MINUS",
            "NO_HOLD_JOBS_AFTER_END",
            "NO_PURGE_COMP",
            "MAGNETIC",
            "SKIP",
            "HOURLY",
            "NO_HOURLY",
            "USER_DELETE",
            "NO_USER_DELETE",
            "REOCCURRING",
        ]
    ]


class Fairshare(BaseModel):
    factor: V42Float64NoValStruct | None = Field(None, description="Fairshare factor")
    level: V42Float64NoValStruct | None = Field(
        None,
        description="Fairshare factor at this level; stored on an assoc as a long double, but that is not needed for display in sshare",
    )


class V42SharesUint64Tres(BaseModel):
    name: str | None = Field(None, description="TRES name")
    value: V42Uint64NoValStruct | None = Field(None, description="TRES value")


class V42SharesFloat128TresList(RootModel[list[V42SharesFloat128Tres]]):
    root: list[V42SharesFloat128Tres]


class V42OpenapiMeta(BaseModel):
    plugin: Plugin | None = None
    client: Client | None = None
    command: V42StringArray | None = Field(None, description="CLI command (if applicable)")
    slurm: Slurm | None = None


class V42OpenapiErrors(RootModel[list[V42OpenapiError]]):
    root: list[V42OpenapiError]


class V42OpenapiWarnings(RootModel[list[V42OpenapiWarning]]):
    root: list[V42OpenapiWarning]


class V42OpenapiResp(BaseModel):
    meta: V42OpenapiMeta | None = Field(None, description="Slurm meta values")
    errors: V42OpenapiErrors | None = Field(None, description="Query errors")
    warnings: V42OpenapiWarnings | None = Field(None, description="Query warnings")


class V42StatsMsgRpcsByType(RootModel[list[V42StatsMsgRpcType]]):
    root: list[V42StatsMsgRpcType] = Field(..., description="RPCs by type")


class V42StatsMsgRpcsByUser(RootModel[list[V42StatsMsgRpcUser]]):
    root: list[V42StatsMsgRpcUser] = Field(..., description="RPCs by user")


class V42StatsMsgRpcsQueue(RootModel[list[V42StatsMsgRpcQueue]]):
    root: list[V42StatsMsgRpcQueue] = Field(..., description="Pending RPCs")


class V42StatsMsgRpcDump(BaseModel):
    type_id: int = Field(..., description="Message type as integer")
    message_type: str = Field(..., description="Message type as string")
    count: V42HostlistString = Field(..., description="Number of RPCs received")


class V42ControllerPingArray(RootModel[list[V42ControllerPing]]):
    root: list[V42ControllerPing]


class V42Licenses(RootModel[list[V42License]]):
    root: list[V42License]


class V42OpenapiJobSubmitResponse(BaseModel):
    job_id: int | None = Field(None, description="submitted Job ID")
    step_id: str | None = Field(None, description="submitted Step ID")
    job_submit_user_msg: str | None = Field(None, description="Job submission user message")
    meta: V42OpenapiMeta | None = Field(None, description="Slurm meta values")
    errors: V42OpenapiErrors | None = Field(None, description="Query errors")
    warnings: V42OpenapiWarnings | None = Field(None, description="Query warnings")


class V42CronEntry(BaseModel):
    flags: V42CronEntryFlags | None = Field(None, description="Flags")
    minute: str | None = Field(
        None,
        description="Ranged string specifying eligible minute values (e.g. 0-10,50)",
    )
    hour: str | None = Field(None, description="Ranged string specifying eligible hour values (e.g. 0-5,23)")
    day_of_month: str | None = Field(
        None,
        description="Ranged string specifying eligible day of month values (e.g. 0-10,29)",
    )
    month: str | None = Field(None, description="Ranged string specifying eligible month values (e.g. 0-5,12)")
    day_of_week: str | None = Field(
        None,
        description="Ranged string specifying eligible day of week values (e.g.0-3,7)",
    )
    specification: str | None = Field(
        None,
        description="Complete time specification (* means valid for all allowed values) - minute hour day_of_month month day_of_week",
    )
    command: str | None = Field(None, description="Command to run")
    line: Line | None = None


class V42OpenapiJobAllocResp(BaseModel):
    job_id: int | None = Field(None, description="Submitted Job ID")
    job_submit_user_msg: str | None = Field(None, description="Job submission user message")
    meta: V42OpenapiMeta | None = Field(None, description="Slurm meta values")
    errors: V42OpenapiErrors | None = Field(None, description="Query errors")
    warnings: V42OpenapiWarnings | None = Field(None, description="Query warnings")


class V42ProcessExitCodeVerbose(BaseModel):
    status: V42ProcessExitCodeStatus | None = Field(None, description="Status given by return code")
    return_code: V42Uint32NoValStruct | None = Field(None, description="Process return code (numeric)")
    signal: Signal | None = None


class V42JobResCore(BaseModel):
    index: int = Field(..., description="Core index")
    status: V42JobResCoreStatus = Field(..., description="Core status")


class V42PriorityByPartition(RootModel[list[V42PartPrio]]):
    root: list[V42PartPrio]


class V42KillJobsRespMsg(RootModel[list[V42KillJobsRespJob]]):
    root: list[V42KillJobsRespJob] = Field(..., description="List of jobs signal responses")


class V42KillJobsMsg(BaseModel):
    account: str | None = Field(None, description="Filter jobs to a specific account")
    flags: V42WarnFlags | None = Field(None, description="Filter jobs according to flags")
    job_name: str | None = Field(None, description="Filter jobs to a specific name")
    jobs: V42KillJobsMsgJobsArray | None = Field(None, description="List of jobs to signal")
    partition: str | None = Field(None, description="Filter jobs to a specific partition")
    qos: str | None = Field(None, description="Filter jobs to a specific QOS")
    reservation: str | None = Field(None, description="Filter jobs to a specific reservation")
    signal: str | None = Field(None, description="Signal to send to jobs")
    job_state: V42JobState | None = Field(None, description="Filter jobs to a specific state")
    user_id: str | None = Field(None, description="Filter jobs to a specific numeric user id")
    user_name: str | None = Field(None, description="Filter jobs to a specific user name")
    wckey: str | None = Field(None, description="Filter jobs to a specific wckey")
    nodes: V42HostlistString | None = Field(None, description="Filter jobs to a set of nodes")


class V42JobArrayResponseArray(RootModel[list[V42JobArrayResponseMsgEntry]]):
    root: list[V42JobArrayResponseMsgEntry]


class V42OpenapiKillJobResp(BaseModel):
    status: V42KillJobsRespMsg = Field(..., description="resultant status of signal request")
    meta: V42OpenapiMeta | None = Field(None, description="Slurm meta values")
    errors: V42OpenapiErrors | None = Field(None, description="Query errors")
    warnings: V42OpenapiWarnings | None = Field(None, description="Query warnings")


class V42Node(BaseModel):
    architecture: str | None = Field(None, description="Computer architecture")
    burstbuffer_network_address: str | None = Field(
        None, description="Alternate network path to be used for sbcast network traffic"
    )
    boards: int | None = Field(None, description="Number of Baseboards in nodes with a baseboard controller")
    boot_time: V42Uint64NoValStruct | None = Field(None, description="Time when the node booted (UNIX timestamp)")
    cluster_name: str | None = Field(None, description="Cluster name (only set in federated environments)")
    cores: int | None = Field(None, description="Number of cores in a single physical processor socket")
    specialized_cores: int | None = Field(None, description="Number of cores reserved for system use")
    cpu_binding: int | None = Field(None, description="Default method for binding tasks to allocated CPUs")
    cpu_load: int | None = Field(None, description="CPU load as reported by the OS")
    free_mem: V42Uint64NoValStruct | None = Field(
        None, description="Total memory in MB currently free as reported by the OS"
    )
    cpus: int | None = Field(None, description="Total CPUs, including cores and threads")
    effective_cpus: int | None = Field(None, description="Number of effective CPUs (excluding specialized CPUs)")
    specialized_cpus: str | None = Field(
        None,
        description="Abstract CPU IDs on this node reserved for exclusive use by slurmd and slurmstepd",
    )
    energy: V42AcctGatherEnergy | None = Field(None, description="Energy usage data")
    external_sensors: dict[str, Any] | None = None
    extra: str | None = Field(
        None,
        description="Arbitrary string used for node filtering if extra constraints are enabled",
    )
    power: dict[str, Any] | None = None
    features: V42CsvString | None = Field(None, description="Available features")
    active_features: V42CsvString | None = Field(None, description="Currently active features")
    gpu_spec: str | None = Field(None, description="CPU cores reserved for jobs that also use a GPU")
    gres: str | None = Field(None, description="Generic resources")
    gres_drained: str | None = Field(None, description="Drained generic resources")
    gres_used: str | None = Field(None, description="Generic resources currently in use")
    instance_id: str | None = Field(None, description="Cloud instance ID")
    instance_type: str | None = Field(None, description="Cloud instance type")
    last_busy: V42Uint64NoValStruct | None = Field(
        None, description="Time when the node was last busy (UNIX timestamp)"
    )
    mcs_label: str | None = Field(None, description="Multi-Category Security label")
    specialized_memory: int | None = Field(
        None, description="Combined memory limit, in MB, for Slurm compute node daemons"
    )
    name: str | None = Field(None, description="NodeName")
    next_state_after_reboot: V42NodeStates | None = Field(
        None, description="The state the node will be assigned after rebooting"
    )
    address: str | None = Field(None, description="NodeAddr, used to establish a communication path")
    hostname: str | None = Field(None, description="NodeHostname")
    state: V42NodeStates | None = Field(None, description="Node state(s) applicable to this node")
    operating_system: str | None = Field(None, description="Operating system reported by the node")
    owner: str | None = Field(
        None,
        description="User allowed to run jobs on this node (unset if no restriction)",
    )
    partitions: V42CsvString | None = Field(None, description="Partitions containing this node")
    port: int | None = Field(None, description="TCP port number of the slurmd")
    real_memory: int | None = Field(None, description="Total memory in MB on the node")
    res_cores_per_gpu: int | None = Field(None, description="Number of CPU cores per GPU restricted to GPU jobs")
    comment: str | None = Field(None, description="Arbitrary comment")
    reason: str | None = Field(
        None,
        description='Describes why the node is in a "DOWN", "DRAINED", "DRAINING", "FAILING" or "FAIL" state',
    )
    reason_changed_at: V42Uint64NoValStruct | None = Field(None, description="When the reason changed (UNIX timestamp)")
    reason_set_by_user: str | None = Field(None, description="User who set the reason")
    resume_after: V42Uint64NoValStruct | None = Field(
        None,
        description='Number of seconds after the node\'s state is updated to "DOWN" or "DRAIN" before scheduling a node state resume',
    )
    reservation: str | None = Field(None, description="Name of reservation containing this node")
    alloc_memory: int | None = Field(None, description="Total memory in MB currently allocated for jobs")
    alloc_cpus: int | None = Field(None, description="Total number of CPUs currently allocated for jobs")
    alloc_idle_cpus: int | None = Field(None, description="Total number of idle CPUs")
    tres_used: str | None = Field(None, description="Trackable resources currently allocated for jobs")
    tres_weighted: float | None = Field(None, description="Weighted number of billable trackable resources allocated")
    slurmd_start_time: V42Uint64NoValStruct | None = Field(
        None, description="Time when the slurmd started (UNIX timestamp)"
    )
    sockets: int | None = Field(None, description="Number of physical processor sockets/chips on the node")
    threads: int | None = Field(None, description="Number of logical threads in a single physical core")
    temporary_disk: int | None = Field(None, description="Total size in MB of temporary disk storage in TmpFS")
    weight: int | None = Field(None, description="Weight of the node for scheduling purposes")
    tres: str | None = Field(None, description="Configured trackable resources")
    version: str | None = Field(None, description="Slurmd version")


class Oversubscribe(BaseModel):
    jobs: int | None = Field(None, description="Maximum number of jobs allowed to oversubscribe resources")
    flags: V42OversubscribeFlags | None = Field(None, description="Flags applicable to the OverSubscribe setting")


class Maximums(BaseModel):
    cpus_per_node: V42Uint32NoValStruct | None = Field(None, description="MaxCPUsPerNode")
    cpus_per_socket: V42Uint32NoValStruct | None = Field(None, description="MaxCPUsPerSocket")
    memory_per_cpu: int | None = Field(None, description="MaxMemPerCPU or MaxMemPerNode")
    partition_memory_per_cpu: V42Uint64NoValStruct | None = Field(None, description="MaxMemPerCPU")
    partition_memory_per_node: V42Uint64NoValStruct | None = Field(None, description="MaxMemPerNode")
    nodes: V42Uint32NoValStruct | None = Field(None, description="MaxNodes")
    shares: int | None = Field(None, description="OverSubscribe")
    oversubscribe: Oversubscribe | None = None
    time: V42Uint32NoValStruct | None = Field(None, description="MaxTime")
    over_time_limit: V42Uint16NoValStruct | None = Field(None, description="OverTimeLimit")


class Partition(BaseModel):
    state: V42PartitionStates | None = Field(None, description="Current state(s)")


class V42PartitionInfo(BaseModel):
    nodes: Nodes1 | None = None
    accounts: Accounts | None = None
    groups: Groups | None = None
    qos: Qos | None = None
    alternate: str | None = Field(None, description="Alternate")
    tres: Tres1 | None = None
    cluster: str | None = Field(None, description="Cluster name")
    select_type: V42CrType | None = Field(None, description="Scheduler consumable resource selection type")
    cpus: Cpus1 | None = None
    defaults: Defaults | None = None
    grace_time: int | None = Field(None, description="GraceTime")
    maximums: Maximums | None = None
    minimums: Minimums | None = None
    name: str | None = Field(None, description="PartitionName")
    node_sets: str | None = Field(None, description="NodeSets")
    priority: Priority | None = None
    timeouts: Timeouts | None = None
    partition: Partition | None = None
    suspend_time: V42Uint32NoValStruct | None = Field(
        None, description="SuspendTime (GLOBAL if both set and infinite are false)"
    )


class V42ReservationInfoCoreSpec(RootModel[list[V42ReservationCoreSpec]]):
    root: list[V42ReservationCoreSpec]


class V42SharesUint64TresList(RootModel[list[V42SharesUint64Tres]]):
    root: list[V42SharesUint64Tres]


class V42StatsMsgRpcsDump(RootModel[list[V42StatsMsgRpcDump]]):
    root: list[V42StatsMsgRpcDump] = Field(..., description="Pending RPCs by hostlist")


class V42OpenapiPingArrayResp(BaseModel):
    pings: V42ControllerPingArray = Field(..., description="pings")
    meta: V42OpenapiMeta | None = Field(None, description="Slurm meta values")
    errors: V42OpenapiErrors | None = Field(None, description="Query errors")
    warnings: V42OpenapiWarnings | None = Field(None, description="Query warnings")


class V42OpenapiLicensesResp(BaseModel):
    licenses: V42Licenses = Field(..., description="List of licenses")
    last_update: V42Uint64NoValStruct = Field(..., description="Time of last licenses change (UNIX timestamp)")
    meta: V42OpenapiMeta | None = Field(None, description="Slurm meta values")
    errors: V42OpenapiErrors | None = Field(None, description="Query errors")
    warnings: V42OpenapiWarnings | None = Field(None, description="Query warnings")


class V42JobDescMsg(BaseModel):
    account: str | None = Field(None, description="Account associated with the job")
    account_gather_frequency: str | None = Field(
        None, description="Job accounting and profiling sampling intervals in seconds"
    )
    admin_comment: str | None = Field(None, description="Arbitrary comment made by administrator")
    allocation_node_list: str | None = Field(None, description="Local node making the resource allocation")
    allocation_node_port: int | None = Field(None, description="Port to send allocation confirmation to")
    argv: V42StringArray | None = Field(None, description="Arguments to the script")
    array: str | None = Field(None, description="Job array index value specification")
    batch_features: str | None = Field(None, description="Features required for batch script's node")
    begin_time: V42Uint64NoValStruct | None = Field(
        None,
        description="Defer the allocation of the job until the specified time (UNIX timestamp)",
    )
    flags: V42JobFlags | None = Field(None, description="Job flags")
    burst_buffer: str | None = Field(None, description="Burst buffer specifications")
    clusters: str | None = Field(None, description="Clusters that a federated job can run on")
    cluster_constraint: str | None = Field(
        None,
        description="Required features that a federated cluster must have to have a sibling job submitted to it",
    )
    comment: str | None = Field(None, description="Arbitrary comment made by user")
    contiguous: bool | None = Field(None, description="True if job requires contiguous nodes")
    container: str | None = Field(None, description="Absolute path to OCI container bundle")
    container_id: str | None = Field(None, description="OCI container ID")
    core_specification: int | None = Field(None, description="Specialized core count")
    thread_specification: int | None = Field(None, description="Specialized thread count")
    cpu_binding: str | None = Field(None, description="Method for binding tasks to allocated CPUs")
    cpu_binding_flags: V42CpuBindingFlags | None = Field(None, description="Flags for CPU binding")
    cpu_frequency: str | None = Field(None, description="Requested CPU frequency range <p1>[-p2][:p3]")
    cpus_per_tres: str | None = Field(
        None,
        description="Semicolon delimited list of TRES=# values values indicating how many CPUs should be allocated for each specified TRES (currently only used for gres/gpu)",
    )
    crontab: V42CronEntry | None = Field(None, description="Specification for scrontab job")
    deadline: int | None = Field(None, description="Latest time that the job may start (UNIX timestamp)")
    delay_boot: int | None = Field(
        None,
        description="Number of seconds after job eligible start that nodes will be rebooted to satisfy feature specification",
    )
    dependency: str | None = Field(
        None,
        description="Other jobs that must meet certain criteria before this job can start",
    )
    end_time: int | None = Field(None, description="Expected end time (UNIX timestamp)")
    environment: V42StringArray | None = Field(None, description="Environment variables to be set for the job")
    rlimits: Rlimits | None = None
    excluded_nodes: V42CsvString | None = Field(None, description="Comma separated list of nodes that may not be used")
    extra: str | None = Field(
        None,
        description="Arbitrary string used for node filtering if extra constraints are enabled",
    )
    constraints: str | None = Field(None, description="Comma separated list of features that are required")
    group_id: str | None = Field(None, description="Group ID of the user that owns the job")
    hetjob_group: int | None = Field(
        None,
        description="Unique sequence number applied to this component of the heterogeneous job",
    )
    immediate: bool | None = Field(
        None,
        description="If true, exit if resources are not available within the time period specified",
    )
    job_id: int | None = Field(None, description="Job ID")
    kill_on_node_fail: bool | None = Field(None, description="If true, kill job on node failure")
    licenses: str | None = Field(None, description="License(s) required by the job")
    mail_type: V42JobMailFlags | None = Field(None, description="Mail event type(s)")
    mail_user: str | None = Field(None, description="User to receive email notifications")
    mcs_label: str | None = Field(None, description="Multi-Category Security label on the job")
    memory_binding: str | None = Field(None, description="Binding map for map/mask_cpu")
    memory_binding_type: V42MemoryBindingType | None = Field(None, description="Method for binding tasks to memory")
    memory_per_tres: str | None = Field(
        None,
        description="Semicolon delimited list of TRES=# values indicating how much memory in megabytes should be allocated for each specified TRES (currently only used for gres/gpu)",
    )
    name: str | None = Field(None, description="Job name")
    network: str | None = Field(None, description="Network specs for job step")
    nice: int | None = Field(None, description="Requested job priority change")
    tasks: int | None = Field(None, description="Number of tasks")
    oom_kill_step: int | None = Field(None, description="Kill whole step in case of OOM in one of the tasks")
    open_mode: V42OpenMode | None = Field(None, description="Open mode used for stdout and stderr files")
    reserve_ports: int | None = Field(None, description="Port to send various notification msg to")
    overcommit: bool | None = Field(None, description="Overcommit resources")
    partition: str | None = Field(None, description="Partition assigned to the job")
    distribution_plane_size: V42Uint16NoValStruct | None = Field(
        None, description="Plane size specification when distribution specifies plane"
    )
    power_flags: list | None = None
    prefer: str | None = Field(
        None,
        description="Comma separated list of features that are preferred but not required",
    )
    hold: bool | None = Field(None, description="Hold (true) or release (false) job")
    priority: V42Uint32NoValStruct | None = Field(None, description="Request specific job priority")
    profile: V42AcctGatherProfile | None = Field(None, description="Profile used by the acct_gather_profile plugin")
    qos: str | None = Field(None, description="Quality of Service assigned to the job")
    reboot: bool | None = Field(None, description="Node reboot requested before start")
    required_nodes: V42CsvString | None = Field(None, description="Comma separated list of required nodes")
    requeue: bool | None = Field(None, description="Determines whether the job may be requeued")
    reservation: str | None = Field(None, description="Name of reservation to use")
    script: str | None = Field(
        None,
        description="Job batch script; only the first component in a HetJob is populated or honored",
    )
    shared: V42JobShared | None = Field(None, description="How the job can share resources with other jobs, if at all")
    site_factor: int | None = Field(None, description="Site-specific priority factor")
    spank_environment: V42StringArray | None = Field(
        None,
        description="Environment variables for job prolog/epilog scripts as set by SPANK plugins",
    )
    distribution: str | None = Field(None, description="Layout")
    time_limit: V42Uint32NoValStruct | None = Field(None, description="Maximum run time in minutes")
    time_minimum: V42Uint32NoValStruct | None = Field(None, description="Minimum run time in minutes")
    tres_bind: str | None = Field(None, description="Task to TRES binding directives")
    tres_freq: str | None = Field(None, description="TRES frequency directives")
    tres_per_job: str | None = Field(
        None,
        description="Comma separated list of TRES=# values to be allocated for every job",
    )
    tres_per_node: str | None = Field(
        None,
        description="Comma separated list of TRES=# values to be allocated for every node",
    )
    tres_per_socket: str | None = Field(
        None,
        description="Comma separated list of TRES=# values to be allocated for every socket",
    )
    tres_per_task: str | None = Field(
        None,
        description="Comma separated list of TRES=# values to be allocated for every task",
    )
    user_id: str | None = Field(None, description="User ID that owns the job")
    wait_all_nodes: bool | None = Field(None, description="If true, wait to start until after all nodes have booted")
    kill_warning_flags: V42WarnFlags | None = Field(None, description="Flags related to job signals")
    kill_warning_signal: str | None = Field(
        None,
        description='Signal to send when approaching end time (e.g. "10" or "USR1")',
    )
    kill_warning_delay: V42Uint16NoValStruct | None = Field(
        None, description="Number of seconds before end time to send the warning signal"
    )
    current_working_directory: str | None = Field(None, description="Working directory to use for the job")
    cpus_per_task: int | None = Field(None, description="Number of CPUs required by each task")
    minimum_cpus: int | None = Field(None, description="Minimum number of CPUs required")
    maximum_cpus: int | None = Field(None, description="Maximum number of CPUs required")
    nodes: str | None = Field(None, description="Node count range specification (e.g. 1-15:4)")
    minimum_nodes: int | None = Field(None, description="Minimum node count")
    maximum_nodes: int | None = Field(None, description="Maximum node count")
    minimum_boards_per_node: int | None = Field(None, description="Boards per node required")
    minimum_sockets_per_board: int | None = Field(None, description="Sockets per board required")
    sockets_per_node: int | None = Field(None, description="Sockets per node required")
    threads_per_core: int | None = Field(None, description="Threads per core required")
    tasks_per_node: int | None = Field(None, description="Number of tasks to invoke on each node")
    tasks_per_socket: int | None = Field(None, description="Number of tasks to invoke on each socket")
    tasks_per_core: int | None = Field(None, description="Number of tasks to invoke on each core")
    tasks_per_board: int | None = Field(None, description="Number of tasks to invoke on each board")
    ntasks_per_tres: int | None = Field(None, description="Number of tasks that can access each GPU")
    minimum_cpus_per_node: int | None = Field(None, description="Minimum number of CPUs per node")
    memory_per_cpu: V42Uint64NoValStruct | None = Field(
        None, description="Minimum memory in megabytes per allocated CPU"
    )
    memory_per_node: V42Uint64NoValStruct | None = Field(
        None, description="Minimum memory in megabytes per allocated node"
    )
    temporary_disk_per_node: int | None = Field(None, description="Minimum tmp disk space required per node")
    selinux_context: str | None = Field(None, description="SELinux context")
    required_switches: V42Uint32NoValStruct | None = Field(None, description="Maximum number of switches")
    segment_size: V42Uint16NoValStruct | None = Field(None, description="Segment size for topology/block")
    standard_error: str | None = Field(None, description="Path to stderr file")
    standard_input: str | None = Field(None, description="Path to stdin file")
    standard_output: str | None = Field(None, description="Path to stdout file")
    wait_for_switch: int | None = Field(None, description="Maximum time to wait for switches in seconds")
    wckey: str | None = Field(None, description="Workload characterization key")
    x11: V42X11Flags | None = Field(None, description="X11 forwarding options")
    x11_magic_cookie: str | None = Field(None, description="Magic cookie for X11 forwarding")
    x11_target_host: str | None = Field(None, description="Hostname or UNIX socket if x11_target_port=0")
    x11_target_port: int | None = Field(None, description="TCP port")


class V42JobResCoreArray(RootModel[list[V42JobResCore]]):
    root: list[V42JobResCore]


class V42OpenapiKillJobsResp(BaseModel):
    status: V42KillJobsRespMsg = Field(..., description="resultant status of signal request")
    meta: V42OpenapiMeta | None = Field(None, description="Slurm meta values")
    errors: V42OpenapiErrors | None = Field(None, description="Query errors")
    warnings: V42OpenapiWarnings | None = Field(None, description="Query warnings")


class V42OpenapiJobPostResponse(BaseModel):
    results: V42JobArrayResponseArray | None = Field(None, description="Job update results")
    meta: V42OpenapiMeta | None = Field(None, description="Slurm meta values")
    errors: V42OpenapiErrors | None = Field(None, description="Query errors")
    warnings: V42OpenapiWarnings | None = Field(None, description="Query warnings")


class V42Nodes(RootModel[list[V42Node]]):
    root: list[V42Node]


class V42PartitionInfoMsg(RootModel[list[V42PartitionInfo]]):
    root: list[V42PartitionInfo]


class V42ReservationInfo(BaseModel):
    accounts: str | None = Field(None, description="Comma separated list of permitted accounts")
    burst_buffer: str | None = Field(None, description="BurstBuffer")
    core_count: int | None = Field(None, description="CoreCnt")
    core_specializations: V42ReservationInfoCoreSpec | None = Field(None, description="Reserved cores specification")
    end_time: V42Uint64NoValStruct | None = Field(None, description="EndTime (UNIX timestamp)")
    features: str | None = Field(None, description="Features")
    flags: V42ReservationFlags | None = Field(None, description="Flags associated with this reservation")
    groups: str | None = Field(None, description="Groups")
    licenses: str | None = Field(None, description="Licenses")
    max_start_delay: int | None = Field(None, description="MaxStartDelay in seconds")
    name: str | None = Field(None, description="ReservationName")
    node_count: int | None = Field(None, description="NodeCnt")
    node_list: str | None = Field(None, description="Nodes")
    partition: str | None = Field(None, description="PartitionName")
    purge_completed: PurgeCompleted | None = None
    start_time: V42Uint64NoValStruct | None = Field(None, description="StartTime (UNIX timestamp)")
    watts: V42Uint32NoValStruct | None = Field(None, description="32 bit integer number with flags")
    tres: str | None = Field(None, description="Comma separated list of required TRES")
    users: str | None = Field(None, description="Comma separated list of permitted users")


class Tres(BaseModel):
    run_seconds: V42SharesUint64TresList | None = Field(
        None, description="Currently running tres-secs = grp_used_tres_run_secs"
    )
    group_minutes: V42SharesUint64TresList | None = Field(None, description="TRES-minute limit")
    usage: V42SharesFloat128TresList | None = Field(None, description="Measure of each TRES usage")


class V42AssocSharesObjWrap(BaseModel):
    id: int | None = Field(None, description="Association ID")
    cluster: str | None = Field(None, description="Cluster name")
    name: str | None = Field(None, description="Share name")
    parent: str | None = Field(None, description="Parent name")
    partition: str | None = Field(None, description="Partition name")
    shares_normalized: V42Float64NoValStruct | None = Field(None, description="Normalized shares")
    shares: V42Uint32NoValStruct | None = Field(None, description="Number of shares allocated")
    tres: Tres | None = None
    effective_usage: V42Float64NoValStruct | None = Field(None, description="Effective, normalized usage")
    usage_normalized: V42Float64NoValStruct | None = Field(None, description="Normalized usage")
    usage: int | None = Field(None, description="Measure of tresbillableunits usage")
    fairshare: Fairshare | None = None
    type: V42AssocSharesObjWrapType | None = Field(None, description="User or account association")


class V42StatsMsg(BaseModel):
    parts_packed: int | None = Field(None, description="Zero if only RPC statistic included")
    req_time: V42Uint64NoValStruct | None = Field(None, description="When the request was made (UNIX timestamp)")
    req_time_start: V42Uint64NoValStruct | None = Field(
        None, description="When the data in the report started (UNIX timestamp)"
    )
    server_thread_count: int | None = Field(None, description="Number of current active slurmctld threads")
    agent_queue_size: int | None = Field(
        None,
        description="Number of enqueued outgoing RPC requests in an internal retry list",
    )
    agent_count: int | None = Field(None, description="Number of agent threads")
    agent_thread_count: int | None = Field(
        None, description="Total number of active threads created by all agent threads"
    )
    dbd_agent_queue_size: int | None = Field(None, description="Number of messages for SlurmDBD that are queued")
    gettimeofday_latency: int | None = Field(
        None,
        description="Latency of 1000 calls to the gettimeofday() syscall in microseconds, as measured at controller startup",
    )
    schedule_cycle_max: int | None = Field(
        None,
        description="Max time of any scheduling cycle in microseconds since last reset",
    )
    schedule_cycle_last: int | None = Field(None, description="Time in microseconds for last scheduling cycle")
    schedule_cycle_sum: int | None = Field(
        None,
        description="Total run time in microseconds for all scheduling cycles since last reset",
    )
    schedule_cycle_total: int | None = Field(None, description="Number of scheduling cycles since last reset")
    schedule_cycle_mean: int | None = Field(
        None,
        description="Mean time in microseconds for all scheduling cycles since last reset",
    )
    schedule_cycle_mean_depth: int | None = Field(
        None, description="Mean of the number of jobs processed in a scheduling cycle"
    )
    schedule_cycle_per_minute: int | None = Field(None, description="Number of scheduling executions per minute")
    schedule_cycle_depth: int | None = Field(None, description="Total number of jobs processed in scheduling cycles")
    schedule_exit: V42ScheduleExitFields | None = Field(
        None,
        description="Reasons for which the scheduling cycle exited since last reset",
    )
    schedule_queue_length: int | None = Field(None, description="Number of jobs pending in queue")
    jobs_submitted: int | None = Field(None, description="Number of jobs submitted since last reset")
    jobs_started: int | None = Field(None, description="Number of jobs started since last reset")
    jobs_completed: int | None = Field(None, description="Number of jobs completed since last reset")
    jobs_canceled: int | None = Field(None, description="Number of jobs canceled since the last reset")
    jobs_failed: int | None = Field(
        None,
        description="Number of jobs failed due to slurmd or other internal issues since last reset",
    )
    jobs_pending: int | None = Field(None, description="Number of jobs pending at the time of listed in job_state_ts")
    jobs_running: int | None = Field(None, description="Number of jobs running at the time of listed in job_state_ts")
    job_states_ts: V42Uint64NoValStruct | None = Field(
        None, description="When the job state counts were gathered (UNIX timestamp)"
    )
    bf_backfilled_jobs: int | None = Field(
        None,
        description="Number of jobs started through backfilling since last slurm start",
    )
    bf_last_backfilled_jobs: int | None = Field(
        None, description="Number of jobs started through backfilling since last reset"
    )
    bf_backfilled_het_jobs: int | None = Field(
        None,
        description="Number of heterogeneous job components started through backfilling since last Slurm start",
    )
    bf_cycle_counter: int | None = Field(None, description="Number of backfill scheduling cycles since last reset")
    bf_cycle_mean: int | None = Field(
        None,
        description="Mean time in microseconds of backfilling scheduling cycles since last reset",
    )
    bf_depth_mean: int | None = Field(
        None,
        description="Mean number of eligible to run jobs processed during all backfilling scheduling cycles since last reset",
    )
    bf_depth_mean_try: int | None = Field(
        None,
        description="The subset of Depth Mean that the backfill scheduler attempted to schedule",
    )
    bf_cycle_sum: int | None = Field(
        None,
        description="Total time in microseconds of backfilling scheduling cycles since last reset",
    )
    bf_cycle_last: int | None = Field(
        None,
        description="Execution time in microseconds of last backfill scheduling cycle",
    )
    bf_cycle_max: int | None = Field(
        None,
        description="Execution time in microseconds of longest backfill scheduling cycle",
    )
    bf_exit: V42BfExitFields | None = Field(
        None,
        description="Reasons for which the backfill scheduling cycle exited since last reset",
    )
    bf_last_depth: int | None = Field(
        None,
        description="Number of processed jobs during last backfilling scheduling cycle",
    )
    bf_last_depth_try: int | None = Field(
        None,
        description="Number of processed jobs during last backfilling scheduling cycle that had a chance to start using available resources",
    )
    bf_depth_sum: int | None = Field(
        None,
        description="Total number of jobs processed during all backfilling scheduling cycles since last reset",
    )
    bf_depth_try_sum: int | None = Field(
        None,
        description="Subset of bf_depth_sum that the backfill scheduler attempted to schedule",
    )
    bf_queue_len: int | None = Field(
        None,
        description="Number of jobs pending to be processed by backfilling algorithm",
    )
    bf_queue_len_mean: int | None = Field(
        None,
        description="Mean number of jobs pending to be processed by backfilling algorithm",
    )
    bf_queue_len_sum: int | None = Field(
        None,
        description="Total number of jobs pending to be processed by backfilling algorithm since last reset",
    )
    bf_table_size: int | None = Field(
        None,
        description="Number of different time slots tested by the backfill scheduler in its last iteration",
    )
    bf_table_size_sum: int | None = Field(
        None,
        description="Total number of different time slots tested by the backfill scheduler",
    )
    bf_table_size_mean: int | None = Field(
        None,
        description="Mean number of different time slots tested by the backfill scheduler",
    )
    bf_when_last_cycle: V42Uint64NoValStruct | None = Field(
        None,
        description="When the last backfill scheduling cycle happened (UNIX timestamp)",
    )
    bf_active: bool | None = Field(None, description="Backfill scheduler currently running")
    rpcs_by_message_type: V42StatsMsgRpcsByType | None = Field(
        None, description="Most frequently issued remote procedure calls (RPCs)"
    )
    rpcs_by_user: V42StatsMsgRpcsByUser | None = Field(None, description="RPCs issued by user ID")
    pending_rpcs: V42StatsMsgRpcsQueue | None = Field(None, description="Pending RPC statistics")
    pending_rpcs_by_hostlist: V42StatsMsgRpcsDump | None = Field(None, description="Pending RPCs hostlists")


class V42JobDescMsgList(RootModel[list[V42JobDescMsg]]):
    root: list[V42JobDescMsg]


class V42JobAllocReq(BaseModel):
    hetjob: V42JobDescMsgList | None = Field(None, description="HetJob description")
    job: V42JobDescMsg | None = Field(None, description="Job description")


class V42JobResSocket(BaseModel):
    index: int = Field(..., description="Core index")
    cores: V42JobResCoreArray = Field(..., description="Core in socket")


class V42OpenapiNodesResp(BaseModel):
    nodes: V42Nodes = Field(..., description="List of nodes")
    last_update: V42Uint64NoValStruct = Field(..., description="Time of last node change (UNIX timestamp)")
    meta: V42OpenapiMeta | None = Field(None, description="Slurm meta values")
    errors: V42OpenapiErrors | None = Field(None, description="Query errors")
    warnings: V42OpenapiWarnings | None = Field(None, description="Query warnings")


class V42OpenapiPartitionResp(BaseModel):
    partitions: V42PartitionInfoMsg = Field(..., description="List of partitions")
    last_update: V42Uint64NoValStruct = Field(..., description="Time of last partition change (UNIX timestamp)")
    meta: V42OpenapiMeta | None = Field(None, description="Slurm meta values")
    errors: V42OpenapiErrors | None = Field(None, description="Query errors")
    warnings: V42OpenapiWarnings | None = Field(None, description="Query warnings")


class V42ReservationInfoMsg(RootModel[list[V42ReservationInfo]]):
    root: list[V42ReservationInfo]


class V42AssocSharesObjList(RootModel[list[V42AssocSharesObjWrap]]):
    root: list[V42AssocSharesObjWrap]


class V42OpenapiDiagResp(BaseModel):
    statistics: V42StatsMsg = Field(..., description="statistics")
    meta: V42OpenapiMeta | None = Field(None, description="Slurm meta values")
    errors: V42OpenapiErrors | None = Field(None, description="Query errors")
    warnings: V42OpenapiWarnings | None = Field(None, description="Query warnings")


class V42JobSubmitReq(BaseModel):
    script: str | None = Field(None, description="Deprecated; Populate script field in jobs[0] or job")
    jobs: V42JobDescMsgList | None = Field(None, description="HetJob description")
    job: V42JobDescMsg | None = Field(None, description="Job description")


class V42JobResSocketArray(RootModel[list[V42JobResSocket]]):
    root: list[V42JobResSocket]


class V42OpenapiReservationResp(BaseModel):
    reservations: V42ReservationInfoMsg = Field(..., description="List of reservations")
    last_update: V42Uint64NoValStruct = Field(..., description="Time of last reservation change (UNIX timestamp)")
    meta: V42OpenapiMeta | None = Field(None, description="Slurm meta values")
    errors: V42OpenapiErrors | None = Field(None, description="Query errors")
    warnings: V42OpenapiWarnings | None = Field(None, description="Query warnings")


class V42SharesRespMsg(BaseModel):
    shares: V42AssocSharesObjList | None = Field(None, description="Association shares")
    total_shares: int | None = Field(None, description="Total number of shares")


class V42JobResNode(BaseModel):
    index: int = Field(..., description="Node index")
    name: str = Field(..., description="Node name")
    cpus: Cpus | None = None
    memory: Memory | None = None
    sockets: V42JobResSocketArray = Field(..., description="Socket allocations in node")


class V42OpenapiSharesResp(BaseModel):
    shares: V42SharesRespMsg = Field(..., description="fairshare info")
    meta: V42OpenapiMeta | None = Field(None, description="Slurm meta values")
    errors: V42OpenapiErrors | None = Field(None, description="Query errors")
    warnings: V42OpenapiWarnings | None = Field(None, description="Query warnings")


class V42JobResNodes(RootModel[list[V42JobResNode]]):
    root: list[V42JobResNode] = Field(..., description="Job resources for a node")


class Nodes(BaseModel):
    count: int | None = Field(None, description="Number of allocated nodes")
    select_type: V42NodeCrType | None = Field(None, description="Node scheduling selection method")
    list: str | None = Field(None, description="Node(s) allocated to the job")
    whole: bool | None = Field(None, description="Whether whole nodes were allocated")
    allocation: V42JobResNodes | None = Field(None, description="Allocated node resources")


class V42JobRes(BaseModel):
    select_type: V42CrType = Field(..., description="Scheduler consumable resource selection type")
    nodes: Nodes | None = None
    cpus: int = Field(..., description="Number of allocated CPUs")
    threads_per_core: V42Uint16NoValStruct = Field(..., description="Number of processor threads per CPU core")


class V42JobInfo(BaseModel):
    account: str | None = Field(None, description="Account associated with the job")
    accrue_time: V42Uint64NoValStruct | None = Field(
        None, description="When the job started accruing age priority (UNIX timestamp)"
    )
    admin_comment: str | None = Field(None, description="Arbitrary comment made by administrator")
    allocating_node: str | None = Field(None, description="Local node making the resource allocation")
    array_job_id: V42Uint32NoValStruct | None = Field(None, description="Job ID of job array, or 0 if N/A")
    array_task_id: V42Uint32NoValStruct | None = Field(None, description="Task ID of this task in job array")
    array_max_tasks: V42Uint32NoValStruct | None = Field(
        None,
        description="Maximum number of simultaneously running array tasks, 0 if no limit",
    )
    array_task_string: str | None = Field(None, description="String expression of task IDs in this record")
    association_id: int | None = Field(None, description="Unique identifier for the association")
    batch_features: str | None = Field(None, description="Features required for batch script's node")
    batch_flag: bool | None = Field(None, description="True if batch job")
    batch_host: str | None = Field(None, description="Name of host running batch script")
    flags: V42JobFlags | None = Field(None, description="Job flags")
    burst_buffer: str | None = Field(None, description="Burst buffer specifications")
    burst_buffer_state: str | None = Field(None, description="Burst buffer state details")
    cluster: str | None = Field(None, description="Cluster name")
    cluster_features: str | None = Field(None, description="List of required cluster features")
    command: str | None = Field(None, description="Executed command")
    comment: str | None = Field(None, description="Arbitrary comment")
    container: str | None = Field(None, description="Absolute path to OCI container bundle")
    container_id: str | None = Field(None, description="OCI container ID")
    contiguous: bool | None = Field(None, description="True if job requires contiguous nodes")
    core_spec: int | None = Field(None, description="Specialized core count")
    thread_spec: int | None = Field(None, description="Specialized thread count")
    cores_per_socket: V42Uint16NoValStruct | None = Field(None, description="Cores per socket required")
    billable_tres: V42Float64NoValStruct | None = Field(None, description="Billable TRES")
    cpus_per_task: V42Uint16NoValStruct | None = Field(None, description="Number of CPUs required by each task")
    cpu_frequency_minimum: V42Uint32NoValStruct | None = Field(None, description="Minimum CPU frequency")
    cpu_frequency_maximum: V42Uint32NoValStruct | None = Field(None, description="Maximum CPU frequency")
    cpu_frequency_governor: V42Uint32NoValStruct | None = Field(None, description="CPU frequency governor")
    cpus_per_tres: str | None = Field(
        None,
        description="Semicolon delimited list of TRES=# values indicating how many CPUs should be allocated for each specified TRES (currently only used for gres/gpu)",
    )
    cron: str | None = Field(None, description="Time specification for scrontab job")
    deadline: V42Uint64NoValStruct | None = Field(
        None, description="Latest time that the job may start (UNIX timestamp)"
    )
    delay_boot: V42Uint32NoValStruct | None = Field(
        None,
        description="Number of seconds after job eligible start that nodes will be rebooted to satisfy feature specification",
    )
    dependency: str | None = Field(
        None,
        description="Other jobs that must meet certain criteria before this job can start",
    )
    derived_exit_code: V42ProcessExitCodeVerbose | None = Field(None, description="Highest exit code of all job steps")
    eligible_time: V42Uint64NoValStruct | None = Field(
        None, description="Time when the job became eligible to run (UNIX timestamp)"
    )
    end_time: V42Uint64NoValStruct | None = Field(None, description="End time, real or expected (UNIX timestamp)")
    excluded_nodes: str | None = Field(None, description="Comma separated list of nodes that may not be used")
    exit_code: V42ProcessExitCodeVerbose | None = Field(None, description="Exit code of the job")
    extra: str | None = Field(
        None,
        description="Arbitrary string used for node filtering if extra constraints are enabled",
    )
    failed_node: str | None = Field(None, description="Name of node that caused job failure")
    features: str | None = Field(None, description="Comma separated list of features that are required")
    federation_origin: str | None = Field(None, description="Origin cluster's name (when using federation)")
    federation_siblings_active: str | None = Field(None, description="Active sibling job names")
    federation_siblings_viable: str | None = Field(None, description="Viable sibling job names")
    gres_detail: V42JobInfoGresDetail | None = Field(
        None, description="List of GRES index and counts allocated per node"
    )
    group_id: int | None = Field(None, description="Group ID of the user that owns the job")
    group_name: str | None = Field(None, description="Group name of the user that owns the job")
    het_job_id: V42Uint32NoValStruct | None = Field(None, description="Heterogeneous job ID, if applicable")
    het_job_id_set: str | None = Field(None, description="Job ID range for all heterogeneous job components")
    het_job_offset: V42Uint32NoValStruct | None = Field(
        None,
        description="Unique sequence number applied to this component of the heterogeneous job",
    )
    job_id: int | None = Field(None, description="Job ID")
    job_resources: V42JobRes | None = Field(None, description="Resources used by the job")
    job_size_str: V42CsvString | None = Field(None, description="Number of nodes (in a range) required for this job")
    job_state: V42JobState | None = Field(None, description="Current state")
    last_sched_evaluation: V42Uint64NoValStruct | None = Field(
        None, description="Last time job was evaluated for scheduling (UNIX timestamp)"
    )
    licenses: str | None = Field(None, description="License(s) required by the job")
    mail_type: V42JobMailFlags | None = Field(None, description="Mail event type(s)")
    mail_user: str | None = Field(None, description="User to receive email notifications")
    max_cpus: V42Uint32NoValStruct | None = Field(None, description="Maximum number of CPUs usable by the job")
    max_nodes: V42Uint32NoValStruct | None = Field(None, description="Maximum number of nodes usable by the job")
    mcs_label: str | None = Field(None, description="Multi-Category Security label on the job")
    memory_per_tres: str | None = Field(
        None,
        description="Semicolon delimited list of TRES=# values indicating how much memory in megabytes should be allocated for each specified TRES (currently only used for gres/gpu)",
    )
    name: str | None = Field(None, description="Job name")
    network: str | None = Field(None, description="Network specs for the job")
    nodes: str | None = Field(None, description="Node(s) allocated to the job")
    nice: int | None = Field(None, description="Requested job priority change")
    tasks_per_core: V42Uint16NoValStruct | None = Field(None, description="Number of tasks invoked on each core")
    tasks_per_tres: V42Uint16NoValStruct | None = Field(None, description="Number of tasks that can assess each GPU")
    tasks_per_node: V42Uint16NoValStruct | None = Field(None, description="Number of tasks invoked on each node")
    tasks_per_socket: V42Uint16NoValStruct | None = Field(None, description="Number of tasks invoked on each socket")
    tasks_per_board: V42Uint16NoValStruct | None = Field(None, description="Number of tasks invoked on each board")
    cpus: V42Uint32NoValStruct | None = Field(None, description="Minimum number of CPUs required")
    node_count: V42Uint32NoValStruct | None = Field(None, description="Minimum number of nodes required")
    tasks: V42Uint32NoValStruct | None = Field(None, description="Number of tasks")
    partition: str | None = Field(None, description="Partition assigned to the job")
    prefer: str | None = Field(None, description="Feature(s) the job requested but that are not required")
    memory_per_cpu: V42Uint64NoValStruct | None = Field(
        None, description="Minimum memory in megabytes per allocated CPU"
    )
    memory_per_node: V42Uint64NoValStruct | None = Field(
        None, description="Minimum memory in megabytes per allocated node"
    )
    minimum_cpus_per_node: V42Uint16NoValStruct | None = Field(None, description="Minimum number of CPUs per node")
    minimum_tmp_disk_per_node: V42Uint32NoValStruct | None = Field(
        None, description="Minimum tmp disk space required per node"
    )
    power: Power | None = None
    preempt_time: V42Uint64NoValStruct | None = Field(
        None, description="Time job received preemption signal (UNIX timestamp)"
    )
    preemptable_time: V42Uint64NoValStruct | None = Field(
        None, description="Time job becomes eligible for preemption (UNIX timestamp)"
    )
    pre_sus_time: V42Uint64NoValStruct | None = Field(
        None, description="Total run time prior to last suspend in seconds"
    )
    hold: bool | None = Field(None, description="Hold (true) or release (false) job")
    priority: V42Uint32NoValStruct | None = Field(None, description="Request specific job priority")
    priority_by_partition: V42PriorityByPartition | None = Field(
        None,
        description="Prospective job priority in each partition that may be used by this job",
    )
    profile: V42AcctGatherProfile | None = Field(None, description="Profile used by the acct_gather_profile plugin")
    qos: str | None = Field(
        None,
        description="Quality of Service assigned to the job, if pending the QOS requested",
    )
    reboot: bool | None = Field(None, description="Node reboot requested before start")
    required_nodes: str | None = Field(None, description="Comma separated list of required nodes")
    required_switches: int | None = Field(None, description="Maximum number of switches")
    requeue: bool | None = Field(None, description="Determines whether the job may be requeued")
    resize_time: V42Uint64NoValStruct | None = Field(None, description="Time of last size change (UNIX timestamp)")
    restart_cnt: int | None = Field(None, description="Number of job restarts")
    resv_name: str | None = Field(None, description="Name of reservation to use")
    scheduled_nodes: str | None = Field(None, description="List of nodes scheduled to be used for the job")
    selinux_context: str | None = Field(None, description="SELinux context")
    shared: V42JobShared | None = Field(None, description="How the job can share resources with other jobs, if at all")
    sockets_per_board: int | None = Field(None, description="Number of sockets per board required")
    sockets_per_node: V42Uint16NoValStruct | None = Field(None, description="Number of sockets per node required")
    start_time: V42Uint64NoValStruct | None = Field(
        None,
        description="Time execution began, or is expected to begin (UNIX timestamp)",
    )
    state_description: str | None = Field(None, description="Optional details for state_reason")
    state_reason: str | None = Field(None, description="Reason for current Pending or Failed state")
    standard_error: str | None = Field(None, description="Path to stderr file")
    standard_input: str | None = Field(None, description="Path to stdin file")
    standard_output: str | None = Field(None, description="Path to stdout file")
    submit_time: V42Uint64NoValStruct | None = Field(
        None, description="Time when the job was submitted (UNIX timestamp)"
    )
    suspend_time: V42Uint64NoValStruct | None = Field(
        None, description="Time the job was last suspended or resumed (UNIX timestamp)"
    )
    system_comment: str | None = Field(None, description="Arbitrary comment from slurmctld")
    time_limit: V42Uint32NoValStruct | None = Field(None, description="Maximum run time in minutes")
    time_minimum: V42Uint32NoValStruct | None = Field(None, description="Minimum run time in minutes")
    threads_per_core: V42Uint16NoValStruct | None = Field(
        None, description="Number of processor threads per CPU core required"
    )
    tres_bind: str | None = Field(None, description="Task to TRES binding directives")
    tres_freq: str | None = Field(None, description="TRES frequency directives")
    tres_per_job: str | None = Field(
        None,
        description="Comma separated list of TRES=# values to be allocated per job",
    )
    tres_per_node: str | None = Field(
        None,
        description="Comma separated list of TRES=# values to be allocated per node",
    )
    tres_per_socket: str | None = Field(
        None,
        description="Comma separated list of TRES=# values to be allocated per socket",
    )
    tres_per_task: str | None = Field(
        None,
        description="Comma separated list of TRES=# values to be allocated per task",
    )
    tres_req_str: str | None = Field(None, description="TRES requested by the job")
    tres_alloc_str: str | None = Field(None, description="TRES used by the job")
    user_id: int | None = Field(None, description="User ID that owns the job")
    user_name: str | None = Field(None, description="User name that owns the job")
    maximum_switch_wait_time: int | None = Field(None, description="Maximum time to wait for switches in seconds")
    wckey: str | None = Field(None, description="Workload characterization key")
    current_working_directory: str | None = Field(None, description="Working directory to use for the job")


class V42JobInfoMsg(RootModel[list[V42JobInfo]]):
    root: list[V42JobInfo]


class V42OpenapiJobInfoResp(BaseModel):
    jobs: V42JobInfoMsg = Field(..., description="List of jobs")
    last_backfill: V42Uint64NoValStruct = Field(..., description="Time of last backfill scheduler run (UNIX timestamp)")
    last_update: V42Uint64NoValStruct = Field(..., description="Time of last job change (UNIX timestamp)")
    meta: V42OpenapiMeta | None = Field(None, description="Slurm meta values")
    errors: V42OpenapiErrors | None = Field(None, description="Query errors")
    warnings: V42OpenapiWarnings | None = Field(None, description="Query warnings")
